Index: branches/2016/dev_merge_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90
===================================================================
--- branches/2016/dev_merge_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 7436)
+++ branches/2016/dev_merge_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 7437)
@@ -461,13 +461,10 @@
              IF(ll_tmp1.AND.ll_tmp2) THEN
                zcpx(ji,jj) = 1.0_wp
-               wduflt(ji,jj) = 1.0_wp
              ELSE IF(ll_tmp3) THEN
                ! no worries about sshn(ji+1,jj)-sshn(ji,jj) = 0, it won't happen ! here
                zcpx(ji,jj) = ABS((sshn(ji+1,jj) + ht_0(ji+1,jj) - sshn(ji,jj) - ht_0(ji,jj)) / &
                            &     (sshn(ji+1,jj) - sshn(ji,jj)))
-               wduflt(ji,jj) = 1.0_wp
              ELSE
                zcpx(ji,jj) = 0._wp
-               wduflt(ji,jj) = 0.0_wp
              END IF
       
@@ -479,13 +476,10 @@
              IF(ll_tmp1.AND.ll_tmp2) THEN
                zcpy(ji,jj) = 1.0_wp
-               wdvflt(ji,jj) = 1.0_wp
              ELSE IF(ll_tmp3) THEN
                ! no worries about sshn(ji,jj+1)-sshn(ji,jj) = 0, it won't happen ! here
                zcpy(ji,jj) = ABS((sshn(ji,jj+1) + ht_0(ji,jj+1) - sshn(ji,jj) - ht_0(ji,jj)) / &
                            &     (sshn(ji,jj+1) - sshn(ji,jj)))
-               wdvflt(ji,jj) = 1.0_wp
              ELSE
                zcpy(ji,jj) = 0._wp
-               wdvflt(ji,jj) = 0.0_wp
              END IF
            END DO
Index: branches/2016/dev_merge_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- branches/2016/dev_merge_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 7436)
+++ branches/2016/dev_merge_2016/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 7437)
@@ -155,5 +155,4 @@
       REAL(wp), POINTER, DIMENSION(:,:) :: zhf
       REAL(wp), POINTER, DIMENSION(:,:) :: zcpx, zcpy                 ! Wetting/Dying gravity filter coef.
-      REAL(wp), POINTER, DIMENSION(:,:) :: wduflt1, wdvflt1           ! Wetting/Dying velocity filter coef.
       !!----------------------------------------------------------------------
       !
@@ -167,5 +166,5 @@
       CALL wrk_alloc( jpi,jpj,   zsshu_a, zsshv_a                  )
       CALL wrk_alloc( jpi,jpj,   zhf )
-      IF( ln_wd ) CALL wrk_alloc( jpi, jpj, zcpx, zcpy, wduflt1, wdvflt1 )
+      IF( ln_wd ) CALL wrk_alloc( jpi, jpj, zcpx, zcpy )
       !
       zmdi=1.e+20                               !  missing data indicator for masking
@@ -381,6 +380,4 @@
       IF( .NOT.ln_linssh ) THEN                 ! Variable volume : remove surface pressure gradient
         IF( ln_wd ) THEN                        ! Calculating and applying W/D gravity filters
-          wduflt1(:,:) = 1.0_wp
-          wdvflt1(:,:) = 1.0_wp
           DO jj = 2, jpjm1
              DO ji = 2, jpim1
@@ -398,5 +395,4 @@
                 ELSE
                   zcpx(ji,jj)    = 0._wp
-                  wduflt1(ji,jj) = 0.0_wp
                 END IF
 
@@ -414,5 +410,4 @@
                 ELSE
                   zcpy(ji,jj)    = 0._wp
-                  wdvflt1(ji,jj) = 0.0_wp
                 ENDIF
 
@@ -425,7 +420,7 @@
               DO ji = 2, jpim1
                  zu_trd(ji,jj) = ( zu_trd(ji,jj) - grav * ( sshn(ji+1,jj  ) - sshn(ji  ,jj ) )   &
-                        &                        * r1_e1u(ji,jj) ) * zcpx(ji,jj) * wduflt1(ji,jj)
+                        &                        * r1_e1u(ji,jj) ) * zcpx(ji,jj) 
                  zv_trd(ji,jj) = ( zv_trd(ji,jj) - grav * ( sshn(ji  ,jj+1) - sshn(ji  ,jj ) )   &
-                        &                        * r1_e2v(ji,jj) ) * zcpy(ji,jj) * wdvflt1(ji,jj)
+                        &                        * r1_e2v(ji,jj) ) * zcpy(ji,jj) 
               END DO
            END DO
@@ -757,6 +752,4 @@
           &            + za2 *  sshb_e(:,:) + za3 *  sshbb_e(:,:)
          IF( ln_wd ) THEN                   ! Calculating and applying W/D gravity filters
-           wduflt1(:,:) = 1._wp
-           wdvflt1(:,:) = 1._wp
            DO jj = 2, jpjm1
               DO ji = 2, jpim1
@@ -774,5 +767,4 @@
                  ELSE
                     zcpx(ji,jj)    = 0._wp
-                    wduflt1(ji,jj) = 0._wp
                  END IF
 
@@ -790,5 +782,4 @@
                  ELSE
                     zcpy(ji,jj)    = 0._wp
-                    wdvflt1(ji,jj) = 0._wp
                  END IF
               END DO
@@ -1093,5 +1084,5 @@
       CALL wrk_dealloc( jpi,jpj,   zsshu_a, zsshv_a                                   )
       CALL wrk_dealloc( jpi,jpj,   zhf )
-      IF( ln_wd ) CALL wrk_dealloc( jpi, jpj, zcpx, zcpy, wduflt1, wdvflt1 )
+      IF( ln_wd ) CALL wrk_dealloc( jpi, jpj, zcpx, zcpy )
       !
       IF ( ln_diatmb ) THEN