Index: branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/ORCA2_OFF_PISCES_QUOTA/EXP00/namelist_pisces_ref
===================================================================
--- branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/ORCA2_OFF_PISCES_QUOTA/EXP00/namelist_pisces_ref	(revision 7617)
+++ branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/ORCA2_OFF_PISCES_QUOTA/EXP00/namelist_pisces_ref	(revision 7618)
@@ -49,23 +49,23 @@
    niter1max  =  1        ! Maximum number of iterations for POC
    niter2max  =  1        ! Maximum number of iterations for GOC
-   wfep       =  0.2      ! FeP sinking speed
-   ldocp      =  1.E-5    ! Phyto ligand production per unit doc
-   ldocz      =  1.E-5    ! Zoo ligand production per unit doc
-   lthet      =  0.5      ! Proportional loss of ligands due to Fe uptake
+!   wfep       =  0.2      ! FeP sinking speed
+!   ldocp      =  1.E-5    ! Phyto ligand production per unit doc
+!   ldocz      =  1.E-5    ! Zoo ligand production per unit doc
+!   lthet      =  0.5      ! Proportional loss of ligands due to Fe uptake
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 &nampislim     !   parameters for nutrient limitations
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-   concnno3   =  3e-6     ! Nitrate half saturation of nanophytoplankton
+   concnno3   =  4e-6     ! Nitrate half saturation of nanophytoplankton
    concpno3   =  1e-6
    concdno3   =  4E-6     ! Phosphate half saturation for diatoms
-   concnnh4   =  1.5E-6   ! NH4 half saturation for phyto
-   concpnh4   =  4E-7
-   concdnh4   =  2E-6     ! NH4 half saturation for diatoms
-   concnpo4   =  3E-6     ! PO4 half saturation for phyto
-   concppo4   =  1.5E-6
+   concnnh4   =  1.2E-6   ! NH4 half saturation for phyto
+   concpnh4   =  3E-7
+   concdnh4   =  1.2E-6     ! NH4 half saturation for diatoms
+   concnpo4   =  4E-6     ! PO4 half saturation for phyto
+   concppo4   =  1E-6
    concdpo4   =  4E-6     ! PO4 half saturation for diatoms
-   concnfer   =  3E-9   ! Iron half saturation for phyto
-   concpfer   =  1.5E-9
+   concnfer   =  4E-9   ! Iron half saturation for phyto
+   concpfer   =  1E-9
    concdfer   =  4E-9   ! Iron half saturation for diatoms
    concbfe    =  1.E-11   ! Half-saturation for Fe limitation of Bacteria
@@ -76,8 +76,8 @@
    xsizephy   =  1.E-6    ! Minimum size criteria for phyto
    xsizepic   =  1.E-6
-   xsizern    =  1.0      ! Size ratio for nanophytoplankton
+   xsizern    =  3.0      ! Size ratio for nanophytoplankton
    xsizerp    =  1.0
-   xsizerd    =  4.0      ! Size ratio for diatoms
-   xksi1      =  2.E-6    ! half saturation constant for Si uptake
+   xsizerd    =  3.0      ! Size ratio for diatoms
+   xksi1      =  8.E-6    ! half saturation constant for Si uptake
    xksi2      =  20E-6  ! half saturation constant for Si/C
    xkdoc      =  417.E-6  ! half-saturation constant of DOC remineralization
@@ -92,13 +92,13 @@
    qnnmin     =  0.29
    qnnmax     =  1.39
-   qpnmin     =  0.28
+   qpnmin     =  0.24
    qpnmax     =  1.06
    qnpmin     =  0.42
    qnpmax     =  1.39
-   qppmin     =  0.25
+   qppmin     =  0.19
    qppmax     =  0.7
    qndmin     =  0.25
    qndmax     =  1.39
-   qpdmin     =  0.29
+   qpdmin     =  0.24
    qpdmax     =  1.32
    qfnmax     =  40E-6
@@ -119,7 +119,7 @@
 &nampisprod     !   parameters for phytoplankton growth
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-   pislopen   =  3.       ! P-I slope
-   pislopep   =  3.       ! P-I slope for picophytoplankton
-   pisloped   =  3.       ! P-I slope  for diatoms
+   pislopen   =  4.       ! P-I slope
+   pislopep   =  4.       ! P-I slope for picophytoplankton
+   pisloped   =  4.       ! P-I slope  for diatoms
    xadap      =  0.       ! Adaptation factor to low light
    excretn    =  0.05     ! excretion ratio of phytoplankton
@@ -127,14 +127,14 @@
    excretd    =  0.05     ! excretion ratio of diatoms
    bresp      =  0.02     ! Basal respiration rate
-   thetannm   =  0.25     ! Maximum Chl/N in nanophytoplankton
-   thetanpm   =  0.25     ! Maximum Chl/N in picophytoplankton
-   thetandm   =  0.3      ! Maximum Chl/N in diatoms
+   thetannm   =  0.3     ! Maximum Chl/N in nanophytoplankton
+   thetanpm   =  0.3     ! Maximum Chl/N in picophytoplankton
+   thetandm   =  0.35     ! Maximum Chl/N in diatoms
    chlcmin    =  0.004    ! Minimum Chl/c in phytoplankton
-   grosip     =  0.131    ! mean Si/C ratio
+   grosip     =  0.39     ! mean Si/C ratio
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 &nampismort     !   parameters for phytoplankton sinks
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-   wchl       =  0.01    ! quadratic mortality of phytoplankton
+   wchl       =  0.01     ! quadratic mortality of phytoplankton
    wchlp      =  0.01
    wchld      =  0.01     ! maximum quadratic mortality of diatoms
@@ -148,13 +148,13 @@
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
    part2      =  0.75     ! part of calcite not dissolved in mesozoo guts
-   grazrat2   =  0.85     ! maximal mesozoo grazing rate
-   bmetexc2   =  .true.   ! Metabolic use of excess carbon 
+   grazrat2   =  0.8      ! maximal mesozoo grazing rate
+   bmetexc2   =  .false.   ! Metabolic use of excess carbon 
    resrat2    =  0.005    ! exsudation rate of mesozooplankton
    mzrat2     =  0.02     ! mesozooplankton mortality rate
    xpref2d    =  1.       ! zoo preference for phyto
-   xpref2p    =  1.       ! zoo preference for POC
+   xpref2p    =  0.8      ! zoo preference for POC
    xpref2z    =  1.       ! zoo preference for zoo
    xpref2m    =  0.2      ! meso preference for zoo
-   xpref2c    =  0.3      ! zoo preference for poc
+   xpref2c    =  0.2      ! zoo preference for poc
    xthresh2zoo = 1E-8     ! zoo feeding threshold for mesozooplankton
    xthresh2dia = 1E-8     ! diatoms feeding threshold for mesozooplankton
@@ -162,7 +162,7 @@
    xthresh2mes = 1E-8     ! meso feeding threshold for mesozooplankton
    xthresh2poc = 1E-8     ! poc feeding threshold for mesozooplankton
-   xthresh2    =  3E-7     ! Food threshold for grazing
-   xkgraz2     =  20.E-6   ! half sturation constant for meso grazing
-   epsher2     =  0.5      ! Efficicency of Mesozoo growth
+   xthresh2    = 1E-8     ! Food threshold for grazing
+   xkgraz2     =  20.E-6  ! half sturation constant for meso grazing
+   epsher2     =  0.5     ! Efficicency of Mesozoo growth
    ssigma2     =  0.5     ! Fraction excreted as semi-labile DOM
    srespir2    =  0.2     ! Active respiration
@@ -176,13 +176,13 @@
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
    part       =  0.5      ! part of calcite not dissolved in microzoo gutsa
-   grazrat    =  2.75     ! maximal zoo grazing rate
-   bmetexc    =  .true.   ! Metabolic use of excess carbon
+   grazrat    =  2.5     ! maximal zoo grazing rate
+   bmetexc    =  .false.   ! Metabolic use of excess carbon
    resrat     =  0.03     ! exsudation rate of zooplankton
    mzrat      =  0.005    ! zooplankton mortality rate
    xprefc     =  0.1      ! Microzoo preference for POM
    xprefn     =  1.       ! Microzoo preference for Nanophyto
-   xprefp     =  1.6
-   xprefd     =  1.0      ! Microzoo preference for Diatoms
-   xprefz     =  0.3      ! Microzoo preference for microzooplankton
+   xprefp     =  1.4
+   xprefd     =  0.8      ! Microzoo preference for Diatoms
+   xprefz     =  0.1      ! Microzoo preference for microzooplankton
    xthreshdia =  1.E-8    ! Diatoms feeding threshold for microzooplankton
    xthreshphy =  1.E-8    ! Nanophyto feeding threshold for microzooplankton
@@ -190,5 +190,5 @@
    xthreshzoo =  1.E-8    ! Nanophyto feeding threshold for microzooplankton
    xthreshpoc =  1.E-8    ! POC feeding threshold for microzooplankton
-   xthresh    =  3.E-7    ! Food threshold for feeding
+   xthresh    =  1.E-8    ! Food threshold for feeding
    xkgraz     =  20.E-6   ! half sturation constant for grazing
    epsher     =  0.5      ! Efficiency of microzoo growth
@@ -207,5 +207,5 @@
    xlam1     =  0.005     ! scavenging rate of Iron
    xlamdust  =  150.0     ! Scavenging rate of dust
-   ligand    =  0.6E-9    ! Ligands concentration 
+   ligand    =  0.7E-9    ! Ligands concentration 
    kfep      =  0.        ! Nanoparticle formation rate constant
 /  
@@ -222,5 +222,5 @@
    oxymin    =  1.E-6     ! Half-saturation constant for anoxia
    oxymin2   =  6.E-6     ! Minimum O2 concentration for oxic remin.
-   feratb    =  20E-6     ! Bacterial Fe/C ratio
+   feratb    =  10E-6     ! Bacterial Fe/C ratio
    xkferb    =  3E-10     ! Half-saturation constant for bact. Fe/C
 /
@@ -228,9 +228,9 @@
 &nampispoc     !   parameters for organic particles
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-   xremipc   =  0.02      ! remineralisation rate of POC
-   xremipn   =  0.025     ! remineralisation rate of PON
-   xremipp   =  0.03      ! remineralisation rate of POP
-   jcpoc     =  15        ! Number of lability classes
-   rshape    =  1.0       ! Shape of the gamma function
+   xremipc   =  0.03      ! remineralisation rate of POC
+   xremipn   =  0.035     ! remineralisation rate of PON
+   xremipp   =  0.04      ! remineralisation rate of POP
+   jcpoc     =  15         ! Number of lability classes
+   rshape    =  1.0       ! Shape of the gamma function 
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
@@ -275,6 +275,6 @@
    concfediaz  =  1.e-10   ! Diazotrophs half-saturation Cste for Iron
    hratio      =  1.e+7    ! Fe to 3He ratio assumed for vent iron supply 
-   fep_rats    =  1.       ! Fep/Fer ratio from sed sources
-   fep_rath    =  1.       ! Fep/Fer ratio from sed hydro sources
+!   fep_rats    =  1.       ! Fep/Fer ratio from sed sources
+!   fep_rath    =  1.       ! Fep/Fer ratio from sed hydro sources
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
@@ -381,5 +381,5 @@
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
    ln_pisdmp    =  .true.     !  Relaxation fo some tracers to a mean value
-   nn_pisdmp    =  5475       !  Frequency of Relaxation 
+   nn_pisdmp    =  2190       !  Frequency of Relaxation 
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''